#include <oxstd.h>
#include <oxdraw.h>
#include <oxprob.h>
#import <modelbase>

/* foreward declation of functions(), so that they can be used before it is typed */
/* NOTE: The order counts! */
frequenz(sofs, eofs);		   
readout(quelle, ziel);
MyADF(quelle, j, sofs, eofs);
MyOls(const mY, const mX);
MyARMA(const mY, const mX, const mAR, const mMA);
MyTestDec(const mStat, const mCv);  // statistic, kritische Werte (5% und 10%),
									//returns No or Ys
MyTestDec2(const mStat, const mCv);  // statistic, kritische Werte (5% und 10%),
									//returns 0.5, 0.1 or -1
MyAnalyse(quelle, ziel, sofs, eofs, mMod);
MyAllADF(quelle, ziel, sofs, eofs, mTyn); // mTyn: Mit Trend (yes: 1, no:0)
MyPath(sDatei, sMD, mBranch, mQuant, sofs);
MyPathNEW(sDatei, sMD, sofs);
MyGls(const mYX);
//MyChowLin(quelle, ziel, sofs, eofs, mTyn); // mTyn: Mit Trend (yes: 1, no:0)


readout(quelle, ziel)
{
	decl file = fopen(ziel, "w");
	print( "\n", "ziel: ", ziel, "\n");
	print( "\n", "Quelle: ", quelle, "\n");
	fprint(file, "Diese Datei: ", ziel, "\nQuelldaten aus: ", quelle, "\n");
	fclose(file);		
}

frequenz(sofs, eofs)   //returns year of sample start, subperiod of start year, year of sample end, sub period of sample end
{
	decl msjahr, msunterjahr, mejahr, meunterjahr, T;
		msjahr = sofs[0];
    	mejahr = eofs[0];
		T = mejahr - msjahr;
	if (columns(sofs)>1)
	{
	    msunterjahr = sofs[1];
	    meunterjahr = eofs[1];
		if (columns(sofs[0][])>2) //default: quartal			//
		{												  //
		T = sofs[0][2]*T - msunterjahr + meunterjahr;			//
		}													  //
		else // use default										//
		{														  //
		T = 4*T - msunterjahr + meunterjahr;
		}															//
	}
	else
	{
	    msunterjahr = 0;
	    meunterjahr = 0;
	}
	return{msjahr, msunterjahr, mejahr, meunterjahr, T};
}

MyADF(quelle, jj, sofs, eofs)
{
    decl b, covmat, XX, T, k, e, sigma2, V, SE, Tstat, mpar, R2, adftest, j, mT;
	decl NAME, VarName;
	decl mj = jj[0];  // no. of Var
	decl mTrend;
	decl mADFresTest = zeros(1,3); // test result and corresponding lag order (3 times)
	decl mADFresLag = zeros(1,3); // test result and corresponding lag order (3 times)

	adftest = new PcFiml();

	adftest.LoadXls(quelle);
	adftest.Deterministic(TRUE);
	NAME = adftest->GetAllNames();


	j = 0;
	while (j<3)
	{
	
	if (j==0)
	{
		VarName = NAME[mj];
		mTrend = jj[1];
	}
	else if (j>0)
	{
		VarName = "d"~VarName;
		mTrend = 0;
	}
	
	print("\n");
	print("*************************************************************** \n");
	print("*************** ADF-Test fuer ",VarName," ******************* \n");
	print("*************************************************************** \n");

	adftest.Select(Y_VAR, {VarName, 0, 0} );	 // NAMEk aggregated series
	adftest.Select(U_VAR,  {"Constant", 0, 0} );	 // unrestricted constant

	if (mTrend == 1)
	{
		adftest.Select(U_VAR,  {"Trend", 0, 0} );	 // unrestricted constant
	}
	if (columns(sofs)>1)
	{
		adftest.Select(U_VAR,  {"CSeason", 0, 3} );	 // centered seasonal dummies
	}

	decl mSampl;
    mSampl = frequenz(sofs, eofs);
	adftest.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
//	adftest->SetSample(1991,3,2003,3);

	
	decl mY, mX, mU, sHname, mAdft; //, mpar, mmpar, R2, tstats, coeffs;

	sHname = "d"~VarName;
	
	mY = adftest->GetGroup(Y_VAR);
	mY = diff0(mY,1);
	mT = rows(mY);
	decl adflag = (round(sqrt(mT))-1);

	decl mApp = adftest->GetSelInfo();
	mApp = mApp[3];
	print("\n","MAX ADF-lag: ", adflag, "\n");

	adftest.Append(mY[][0] , sHname, mApp);//(mSampl[4]-1)/6-4, 168
	adftest.Select(Y_VAR, {sHname, 0, 0} );	 // endog. series in 1st difference,
	adftest.DeSelectByName(VarName, Y_VAR, 0);
	adftest.Select(X_VAR, {VarName, 1, 1} );           // lagged dependent vars
	adftest.Select(X_VAR, {sHname, 1, (adflag+1)} );           // lagged dependent vars

	adftest.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	mY = adftest->GetGroup(Y_VAR);
	mX = adftest->GetGroup(X_VAR);
	mU = adftest->GetGroup(U_VAR);
	mT = rows(mY);

	adftest.Estimate();

	decl mLL = adftest->GetUrfLogLik();
	decl mLags = adflag+1;
	mLL = mLL|mLL;
	decl mAdfrt = adftest->GetPi()./(sqrt(adftest->GetVarPi()));
	mAdfrt = mAdfrt[0][0];


	decl i, md;
	for (i = (adflag+1); i > 2; --i)	 // delete the lagged dependent var step by step 
	{
		adftest.DeSelectByName(sHname, X_VAR, i);
		mX = adftest->GetGroup(X_VAR);
		adftest.Estimate();
		md = adftest->GetUrfLogLik();
		mAdft = adftest->GetPi()./(sqrt(adftest->GetVarPi()));
		mAdft = mAdft[0][0];
		mLags = mLags - 1;
		decl mLLt = adftest->GetUrfLogLik();
		mLLt = -2*(mLLt-mLL[0]);
		mLLt = (1-probchi(mLLt , (adflag+2-i)));

		if (mLLt < 0.05)
			{
				i = 2;
				mLL[0] = mLL[1];
				mLags = mLags+1;
				mAdft = mAdfrt;
			}
			else
			{
			mAdfrt = mAdft;
			mLL[1] = md;
			}
	} 	 // i


	if (columns(sofs)>1)		   // Quartalsdaten
		{
		adftest.Select(X_VAR, {sHname, (mLags-1), mLags} );           // lagged dependent vars
		adftest.Select(X_VAR, {sHname, (adflag+1), (adflag+1)} );     // lagged dependent vars to standardise sample

		adftest.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);

		adftest.DeSelectByName(sHname,    X_VAR, (adflag+1));           // lagged dependent vars
		adftest.DeSelectByName("CSeason", U_VAR, 0);
		adftest.DeSelectByName("CSeason", U_VAR, 1);
		adftest.DeSelectByName("CSeason", U_VAR, 2);
		adftest.DeSelectByName("CSeason", U_VAR, 3);

		adftest.Estimate();
	
		mLL = mLL[0]|(adftest->GetUrfLogLik());
    	mLL[0]= -2*(mLL[1]-mLL[0]);
		mLL[0] = (1-probchi(mLL[0] , 4));
			if (mLL[0] > 0.1)
			{
			mAdft = adftest->GetPi()./(sqrt(adftest->GetVarPi()));
			mAdft = mAdft[0][0];
			print("\nESTIMATION WITHOUT CSeasonals\n");
			}
			else
			{
			print("\nESTIMATION WITH CSeasonals\n");
			}
		}

//Some tests take the form of a likelihood ratio (LR) test.
//If l is the unrestricted, and l0 the restricted log-likelihood,
//then -2(l0-l) has a c2(s) distribution, with s the number of
//restrictions imposed (so model l0 is nested in l).

	print("ADF-Teststatistik: ", mAdft, "\n");

	if (mT<=12)
	{
	mAdft = MyTestDec2((-1*mAdft), <4.107833 , 3.515047>); // <5%, 10%>	   3, 2
	mADFresTest[j] = mAdft[0]; // test result and corresponding lag order (3 times)
	mADFresLag[j] = mLags; // test result and corresponding lag order (3 times)
	j = 2;
	}
	else
	{
		if (mT<=50)
		{
		mAdft = MyTestDec2((-1*mAdft), <3.504330 , 3.181826>);
		}
		else // more than 50 obs
		{
		mAdft = MyTestDec2((-1*mAdft), <3.461094 , 3.156776>);
		}
	mADFresTest[j] = mAdft[0]; // test result and corresponding lag order (3 times)
	mADFresLag[j] = mLags; // test result and corresponding lag order (3 times)
	}
print("mAdft: ", (mAdft));
print("mADFresTest: ", mADFresTest);
mT = adftest->GetGroup(Y_VAR);
mT = rows(mT);

	adftest.DeSelect();

		++j;		  // End of loop for three steps
	  }

	return {mADFresTest, mADFresLag, mT};
	delete adftest;
}

MyOls(const mY, const mX)
{
    decl b, covmat, XX, T, k, e, sigma2, V, SE, Tstat, mpar, R2;
    olsc(mY, mX, &b, &covmat, &XX); // covmat = 1/(X'X) and XX = X'X
	T = rows(mY);
	k = columns(mX);
	e = mY - mX * b;
	sigma2=(e'*e)/(T-k);
	V=sigma2*covmat;
	SE=sqrt(diagonal(V));
	Tstat= b'./ SE; 
	mpar = b ~ SE' ~ Tstat';
	R2=1-(e'*e)/(variance(mY));
	return {mpar, R2};
}


MyARMA(const mY, const mX, const mAR, const mMA)
{
    decl b, covmat, XX, T, k, e, sigma2, V, SE, Tstat, mpar, R2;
	decl CMARMA;
	CMARMA = new ArfimaCL();		   // dbase is now a PcFiml object!!
    //------------------------------------------------------- create the model
	CMARMA.DeSelect();										// formulate model
	CMARMA.FixD(0);                  			  // make sure co-integration
    CMARMA.Select(X_VAR, mX );                  // formulate model
//	CMARMA.Select(U_VAR,  { "Constant", 0, 0 } );
    CMARMA.Arma(mAR,mMA);
    CMARMA.GetXBeta(mX);
    CMARMA.GetZGamma(mY);
// Arfima::FilterNaive(const mY, const dYmean,	const vPar(Integration) , const cAR, const cMA,
// const mXBeta, const mZGamma, const adLogDet, ...)
	e = mY'*mY/rows(mY);
   	CMARMA.FilterNaive(mY, e, 0, 0 , 1 , mX, 0);//, 0, 0);
    CMARMA.FreeArma();

	olsc(mY, mX, &b, &covmat, &XX); // covmat = 1/(X'X) and XX = X'X
	T = rows(mY);
	k = columns(mX);
	e = mY - mX * b;
	sigma2=(e'*e)/(T-k);
	V=sigma2*covmat;
	SE=sqrt(diagonal(V));
	Tstat= b'./ SE; 
	mpar = b ~ SE' ~ Tstat';
	R2=1-(e'*e)/(variance(mY));
	return {mpar, R2};
}


MyTestDec(const mStat, const mCv)
	{
	decl Cires, CiAns, CiAns1, CiAns2;

	if (mStat > mCv[0][0])
	{
		CiAns1 = "Ys ";
	}
	else 
	{
		CiAns1 = "No ";
	}
	if (mStat > mCv[0][1])
	{
		CiAns2 = "Ys ";
	}
	else
	{
		CiAns2 = "No  ";
	}

	return {CiAns1, CiAns2};
	}

MyTestDec2(const mStat, const mCv)
	{
	decl Cires, mAns;

	mAns = -1;
	if (mStat > mCv[0][0])
	{
		mAns = 0.05;
	}
	else 
	{
		if (mStat > mCv[0][1])
		{
			mAns = 0.1;
		}
		else
		{
			mAns = -1;
		}
	}

	return {mAns};
	}


MyPath(sDatei, sMD, mBranch, mQuant, sofs)
{
	decl dbase, sInpath, sOutpath, sQuant, sFreq, mNo;
	dbase = new PcFiml();
	decl sBranches;
	dbase.LoadXls(sMD~"Branchennamen.xls");
	sBranches = dbase->GetAllNames();
	mNo = rows(sBranches)-3;
	if (sofs[0][1]>0) // Quarterly data (=related series)
	{
	sFreq = "QUARTERLY";
	sQuant = "";
	}
	else
	{
	sFreq = "ANNUAL/";
	sQuant = sBranches[mNo+mQuant]; //14
	}
    sBranches = sBranches[mBranch-1];
	sInpath = sMD~"INPUT/"~sBranches~"/"~sFreq~sQuant~"/"~sDatei~".xls";
	sOutpath = sMD~"OUTPUT/"~sBranches~"/"~sFreq~sQuant~"/"~sDatei;

	delete dbase;

print("\n", sBranches, "\n");
	

	return{sInpath, sOutpath};
}


MyPathNew(sDatei, sMD, sofs)
{
	decl dbase, sInpath, sOutpath, sQuant, sFreq, mNo;
	dbase = new PcFiml();
	if (sofs[0][2]<=1) // Annual data 
	{
	sFreq = "ANNUAL";
	}
	if (sofs[0][2]==2) // Semi-annual data 
	{
	sFreq = "SEMIANNUAL";
	}
	if (sofs[0][2]==4) // Quarterly data
	{
	sFreq = "QUARTERLY";
	}
	if (sofs[0][2]==12) // Monthly data
	{
	sFreq = "MONTHLY";
	}
	sInpath = sMD~"INPUT/"~sFreq~"/"~sDatei~".xls";
	sOutpath = sMD~"OUTPUT/"~sFreq~"/"~sDatei;

	delete dbase;

	return{sInpath, sOutpath};
}

MyGls(const mYX)
{
//Input: mYX with three components:
//		1) mYX[0] : matrix of dependent variables (row format assumed)
//		2) mYX[1] : matrix of independent variables	 (row format assumed)
//		3) mYX[2] : varance-covariance matrix
	decl b, covmat, XX, T, k, e, sigma2, V, SE, Tstat, mpar, R2, mY, mX, mV;
	mY = mYX[0];
	mX = mYX[1];
	mV = mYX[2];
	b = invert(mX'*invert(mV)*mX)*mX'*invert(mV)*mY;
	XX = mX'*invert(mV)*mX;
	T = rows(mY);
	k = columns(mX);
	e = mY - mX * b;
	sigma2=(e'*invert(mV)*e)/(T-k);
	V=sigma2*invert(XX);
	SE=sqrt(diagonal(V));
print("printing beta ",b, SE);
	Tstat= b'./ SE; 
	mpar = b ~ SE' ~ Tstat';
	R2=1-(e'*e)/(variance(mY));
	return {mpar, R2};
}
