#include <arma.h>
#include <oxstd.h>
#include <oxdraw.h>
#include <oxprob.h>
#import <modelbase>

#import </lib/arfima>
#import <lib/testres>

/* foreward declation of functions(), so that they can be used before it is typed */
/* NOTE: The order counts! */
myfcstwt(quelle, ziel, sofs, eofs, mMod);
myfcstnot(quelle, ziel, sofs, eofs, mMod);	

myfcstwt(quelle, ziel, sofs, eofs, mMod)	 // procedure for testing cointegration, DGP WITH trend
{
	decl dbase, CMARMA, Testdats, YY, XX, NAME, j, jmax, NAMEj, NAMEk;
	decl Cires, CiAns1, CiAns2, mTrnd, mConst;
	decl ResCoeff, ResR2;

	if (mMod<1)
	{
	readout(quelle, (ziel~"_TF.txt"));		 // initialises output file
	}
	else
	{
	readout(quelle, (ziel~"_TFr.txt"));		 // initialises output file
	}	

	dbase = new PcFiml();		   // dbase is now a PcFiml object!!
	CMARMA = new Arfima();		   // CMARMA is now a Arfima object!!
	dbase.LoadXls(quelle);
	NAME = dbase->GetAllNames();
	NAMEk = NAME[0];						 // aggregated series
	jmax = rows(NAME);
	ResR2 = zeros(jmax,1);
	ResCoeff = zeros(jmax,6);
	decl CiAns = zeros(jmax,1);
	decl ergebnis = zeros(jmax,9);

	dbase.Deterministic(TRUE);

	decl mSampl, mT, mADFmaxl;
    mSampl = frequenz(sofs, eofs); //{msjahr, msunterjahr, mejahr, meunterjahr, T};
	mT = mSampl[4];

	//  Supplementary ADF Test
	print("\n ADF-Test ", NAME[0], " \n");
//	print("\n ADF-Test ", NAME, " \n");
//	MyADF(quelle, <1, 5, 1>,  sofs, eofs);		// path for data input,
//										// <number of var to be selected, max lag, trend(1) or not (0)>
//										//start of sample, end of sample
	decl mj = 0|1;
	decl adfreslt = MyADF(quelle, mj,  sofs, eofs);
	decl adfres = adfreslt[0];
	decl mLag = adfreslt[1];
	
	print(mj, "ADF test: ",  adfres[0], mLag[0]);
	ergebnis[0][] = adfres[0]~mLag[0]~-99~-99~-99~-99~-99~-99~adfreslt[2];



	j = 0;
	while (j<(jmax-1))
	{
	NAMEj = NAME[j+1];	   
	print("\n");
	print("*************************************************************** \n");
	print("*************** Regressionen fuer ",NAMEj," ******************* \n");
	print("*************************************************************** \n");

	//Determine the Sample Size first
	dbase.Select(Y_VAR, {NAMEj, 0, 0, NAMEk, 0, 0} );	 // NAMEk aggregated series, NO Lags
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	mT =   dbase->GetGroup(Y_VAR);
	mT = rows(mT);
	mADFmaxl = round(sqrt(mT)/2);
	dbase.DeSelect();
	//End of sample selection	

	dbase.Select(Y_VAR, {NAMEj, 0, mADFmaxl , NAMEk, 0, mADFmaxl} );	 // NAMEk aggregated series,
														// 	NAMEj related series
	dbase.Select(U_VAR,  { "Constant", 0, 0 } );	 // unrestricted constant
	dbase.Select(X_VAR, {"Trend", 0, 0} );           // resticted Trend

	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);

	dbase.Estimate();
	dbase.UnitRootTest();
    dbase.Cointegration();
//	Cires = dbase->Output(FALSE, FALSE);
	Cires = dbase->GetEval();
	Cires = Cires';
	Cires = Cires[][1:2];	   // p-value
	CiAns1 = MyTestDec2((-1*Cires[0][1]), <-0.05, -0.1>) ;
	CiAns[j+1] = CiAns1[0];

// General Model Analyses
	decl my, mx, mu, mpar, mmpar, tstats, coeffs, mPi;
	decl myy, mfy, mxx, mPii;
	decl mE, mYY, mXX, mYYs, mXXs, mXBeta, mMean, sResultate, mForec;

if (mMod <1)
{
//  Supplementary OLS estimation
	print("\n Supplementary OLS ", NAMEj, " on ", NAMEk, " \n");
	dbase.DeSelect();
	dbase.Select(Y_VAR, {NAMEk, 0, 0} );	 // NAMEk aggregated series,
	dbase.Select(U_VAR,  { "Constant", 0, 0 ,"Trend", 0, 0} );	 // unrestricted constant
	dbase.Select(X_VAR, {NAMEj, 0, 0,  "Constant", 0, 0, "Trend", 0, 0} );           // resticted Trend
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	my = dbase->GetGroup(Y_VAR);
	mx = dbase->GetGroup(X_VAR);
	mTrnd = dbase->GetGroup(U_VAR);
	mpar = MyOls(my, mx);
	mmpar = mpar[0];
	ResR2[j+1] = mpar[1];
	tstats = mmpar[][2];
	coeffs = mmpar[][0];
	mPi = mmpar[][0];
	ResCoeff[j+1][] = (coeffs'~tstats') ;
	print("\n End of Supplementary OLS ", NAMEk, " \n \n");
//  End of Supplementary OLS estimation		xls		  adf

//  Supplementary OLS forecasting
	print("\n Supplementary OLS: ", NAMEj, " on ", NAMEk, " \n");
	dbase.DeSelect();
	dbase.Select(Y_VAR, {NAMEk, 0, 0} );	 // NAMEk aggregated series,
	dbase.Select(U_VAR,  { "Constant", 0, 0 } );	 // unrestricted constant
	dbase.Select(X_VAR, {NAMEj, 0, 0,  "Constant", 0, 0, "Trend", 0, 0} );           // resticted Trend
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	my = dbase->GetGroup(Y_VAR);
	myy = my[0:rows(my)-3][];
	mx = dbase->GetGroup(X_VAR);
	mxx = mx[0:rows(mx)-3][];
//	mpar = MyARMA(myy, mxx, 0, 1);
	mpar = MyOls(myy, mxx);
	mPii = mpar[0];
	mPii = mPii[][0];
	/* The actual forecasting  part */
	mfy = mx*mPii;	 // forecasted series
	mfy = (mfy[(rows(my)-2):][] - my[(rows(my)-2):][])./(my[(rows(my)-2):][])*100;
	mfy = mfy'mfy; /* Vorhersagefehlerquadratsumme */
	mPii = (mPii[0]-mPi[0])/mPi[0]; // Variation of coefficient
	mPii = fabs(mPii[0]);
	print("\n End of Supplementary OLS Forecasting ", NAMEj, " on ", NAMEk, " \n \n");
//  End of Supplementary OLS forecasting
}
 else
{
//Supplementary ARMA
	CMARMA.LoadXls(quelle);		// create database as member
    CMARMA.Deterministic(FALSE);// create Constant,Trend,Seasonals
    //------------------------------------------------------- create the model
	CMARMA.DeSelect();										// formulate model
	CMARMA.Select(Y_VAR, {NAMEk,0,0} );                  // NAMEk aggregated series,
//	CMARMA.Select(Z_VAR, {NAMEj, 0, 0} );	 // explanatory Var
	CMARMA.Select(X_VAR, {"Constant", 0, 0, "Trend", 0, 0, NAMEj, 0, 0}); //, "trend()", 0, 0} );	 
	CMARMA.SetSelSample((mSampl[0]),mSampl[1],(mSampl[2]),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
	my = CMARMA->GetGroup(Y_VAR);
	//End of sample selection	

    CMARMA.Arma(0,1);
   	CMARMA.UseSampleMean();
	CMARMA.FixD(0.0);                  			  // make sure co-integration
	CMARMA.Estimate();
	mMean = CMARMA->GetSigma2();
	mXBeta = CMARMA.GetFreePar();
	mPi = mXBeta[rows(mXBeta)-1];
	sResultate = CMARMA.GetStdErr();
	tstats = (mXBeta) ./ sResultate[1:rows(sResultate)-1];
	tstats = tstats[rows(mXBeta)-1]~tstats[2]~tstats[0];
	coeffs = mXBeta[rows(mXBeta)-1]~mXBeta[2]~mXBeta[0];
	ResCoeff[j+1][] = (coeffs~tstats) ;
	// Pseudo - R-square
	mMean = (varc(my) - mMean)/ varc(my);
	ResR2[j+1] = mMean;

	/* The actual forecasting  part */
	myy = CMARMA.GetSelEnd();
	CMARMA.SetSelSample((mSampl[0]-2),mSampl[1],(mSampl[2]-2),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
if (myy > CMARMA.GetSelEnd())
	{
	if ((rows(my)-2)>rows(mXBeta))
		{
		CMARMA.Estimate();
		mForec = CMARMA.Forecast(2); // mX in the arfima.ox code
		mXBeta = CMARMA.GetFreePar();
		mPii = mXBeta[rows(mXBeta)-1];
		mForec = (mForec[][4])./(mForec[][0] + mForec[][4])*100; // forecast statistic
		mfy = mForec'mForec; /* Vorhersagefehlerquadratsumme */
		mPii = (mPii-mPi)/mPi; // Variation of coefficient
		mPii = fabs(mPii);
		}
	}
else
	{
	mfy =-99;
	mPii = -99;
	}
	CMARMA.SetSelSample((mSampl[0]),mSampl[1],(mSampl[2]),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
// end of auxiliary ARMA
}


//					  Joh.-Test	~OLS coeffs, t-stats												~ OLS-R^2
	ergebnis[j+1][] = CiAns[j+1]~ResCoeff[j+1][0]~ResCoeff[j+1][3]~ResCoeff[j+1][2]~ResCoeff[j+1][5]~ResR2[j+1]~mfy~mPii~rows(my);

	dbase.DeSelect();					
	++j;
	}  // for j-loop 

//			ResCoeff = ResCoeff[][0]~ResCoeff[][3]~ResCoeff[][2]~ResCoeff[][5]~ResR2;
			format(600);
			sprintbuffer(25480);
			decl sample, sTrend, sTTrend, sR2, sTac;
	if (mMod<1)
	{
			 sTrend = "trend";
			 sTTrend = 	"t(Trend)";
			 sR2 = 	"R2";
			 sTac = "F";
			 sample = dbase.GetSelSample();
	}
	else
	{
			 sTrend = "rho";
			 sTTrend = 	"t(rho)";			 
			 sR2 = 	"pseudo-R2";
			 sTac = "Fr";
			sample = CMARMA.GetSelSample();
			delete CMARMA;
	 }
			
			print("\nModel has TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], " for ", sample, "\n",
			"%r", NAME, //CiAns
			"%c", {	   "Joh",  "coeff.", "t(coeff)",    sTrend,   sTTrend,       sR2,  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#12.2g", "%#12.4g", "%#10.4g", "%#12.4g", "%#8.4g", "%6.2g"}
			,ergebnis,
			"\nThese results (without header) are to be found at:\n", ziel~"_TFr.dat",
			"\nThis file: ", ziel~"_T"~sTac~".txt"); 		  // ResCoeff %#d
//	decl ergebnis; d: integer, g: double, "%#13.5g"
	ergebnis = sprint(
			"%r", NAME,	//CiAns
			"%c", {	   "Joh",  "coeff.", "t(coeff)",    sTrend,   sTTrend,       sR2,  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#12.2g", "%#12.4g", "%#10.4g", "%#12.4g", "%#8.4g", "%6.2g"}
			,ergebnis); 		  // ResCoeff %#d

	decl file = fopen((ziel~"_T"~sTac~".dat"), "w");
	fprint(file, ergebnis);
	fclose(file);		

	ergebnis = sprint("\nModel has TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], " for ", sample, "\n",
			"%r", NAME, //CiAns
			"%c", {	   "Joh",  "coeff.", "t(coeff)",    sTrend,   sTTrend,       sR2,  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#12.2g", "%#12.4g", "%#10.4g", "%#12.4g", "%#8.4g", "%6.2g"}
			,ergebnis, 
			"\nNOTE: Var(C) gives the variation of the behavioural coefficient with respect to sample size variation.\n",
			"\nIt should by no means exceed 1.\n",
			"\nThese results (without header) are to be found at:\n", ziel~"_TFr.dat",
			"\nThis file: ", ziel~"_T"~sTac~".txt"); 		  // ResCoeff %#d
	file = fopen((ziel~"_T"~sTac~".txt"), "w");
	fprint(file, ergebnis);
	fclose(file);		


	delete dbase;
// END OF MYFCSTWT()
}

myfcstnot(quelle, ziel, sofs, eofs, mMod)
{
	decl dbase, CMARMA, Testdats, YY, XX, NAME, j, jmax, NAMEj, NAMEk;
	decl Cires, CiAns1, CiAns2;
	decl ResCoeff, ResR2, ergebnis;


	dbase = new PcFiml();		 // create a new object (dbase)
	dbase.LoadXls(quelle);
	NAME = dbase->GetAllNames();
	NAMEk = NAME[0];						 // aggregated series
	jmax = rows(NAME);
	ResR2 = zeros(jmax,1);
	decl CiAns = zeros(jmax,1);
	if (mMod<1)
		{
		ResCoeff = zeros(jmax,4);
		ergebnis = zeros(jmax,7);
		readout(quelle, (ziel~"_F.txt"));		 // initialises output file
		}
	else 
		{
		ResCoeff = zeros(jmax,6);
		ergebnis = zeros(jmax,9);
		readout(quelle, (ziel~"_Fr.txt"));		 // initialises output file
	}		
	dbase.Deterministic(TRUE);

	decl mSampl, mT, mADFmaxl;
    mSampl = frequenz(sofs, eofs);
	mT = mSampl[4];

	//  Supplementary ADF Test for first entry (dependent := aggregated variabele)
	print("\n ADF-Test ", NAME[0], " \n");
//	print("\n ADF-Test ", NAME, " \n");
//	MyADF(quelle, <1, 5, 1>,  sofs, eofs);		// path for data input,
//										// <number of var to be selected, max lag, trend(1) or not (0)>
//										//start of sample, end of sample
	decl mj = 0|0;
	decl adfreslt = MyADF(quelle, mj,  sofs, eofs);
	decl adfres = adfreslt[0];
	decl mLag = adfreslt[1];
	
	print(mj, "ADF test: ",  adfres[0], mLag[0]);
	if (mMod<1)
		{
		ergebnis[0][] = adfres[0]~mLag[0]~-99~-99~-99~-99;
		}
	else	
		{
		ergebnis[0][] = adfres[0]~mLag[0]~-99~-99~-99~-99~-99~-99;
		}

	j = 0;
	while (j<(jmax-1))
	{
	NAMEj = NAME[j+1];	   
	print("\n");
	print("*************************************************************** \n");
	print("*************** Regressionen fuer ",NAMEj," ******************* \n");
	print("*************************************************************** \n");  //(round(sqrt(mT)-1)

	//Determine the Sample Size first
	dbase.Select(Y_VAR, {NAMEj, 0, 0, NAMEk, 0, 0} );	 // NAMEk aggregated series, NO Lags
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	mT =   dbase->GetGroup(Y_VAR);
	mT = rows(mT);
	mADFmaxl = round(sqrt(mT)/2);
	dbase.DeSelect();
	//End of sample selection	

	dbase.Select(Y_VAR, {NAMEj, 0, mADFmaxl, NAMEk, 0, mADFmaxl} );	 // NAMEk aggregated series,
														// 	NAMEj related series

	dbase.Select(U_VAR,  { "Constant", 0, 0 } );	 // unrestricted constant

	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);


	dbase.Estimate();
    dbase.Cointegration();
	Cires = dbase->Output(FALSE, FALSE);
	Cires = dbase->GetEval();
	Cires = Cires';
	Cires = Cires[][1:2];
	CiAns1 = MyTestDec2((-1*Cires[0][1]), <-0.05, -0.1>) ;
	CiAns[j+1] = CiAns1[0];	

// General Model Analyses
	decl my, mx, mu, mpar, mmpar, tstats, coeffs, mPi;
	decl myy, mfy, mxx, mPii;
	decl mE, mYY, mXX, mYYs, mXXs, mXBeta, mMean, sResultate, mForec;

if (mMod <1)
{
//  Supplementary OLS estimation
	print("\n Supplementary OLS: ", NAMEj, " on ", NAMEk, " \n");
	dbase.DeSelect();
	dbase.Select(Y_VAR, {NAMEk, 0, 0} );	 // NAMEk aggregated series,
	dbase.Select(U_VAR,  { "Constant", 0, 0 } );	 // unrestricted constant
	dbase.Select(X_VAR, {NAMEj, 0, 0,  "Constant", 0, 0} );           // resticted Trend
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	my = dbase->GetGroup(Y_VAR);
	mx = dbase->GetGroup(X_VAR);
	mpar = MyOls(my, mx);
	mmpar = mpar[0];
	ResR2[j+1] = mpar[1];
	tstats = mmpar[][2];
	coeffs = mmpar[][0];
	mPi =  mmpar[][0];
	ResCoeff[j+1][] = (coeffs'~tstats') ;
	print("\n End of Supplementary OLS ", NAMEj, " on ", NAMEk, " \n \n");
//  End of Supplementary OLS estimation function
	
//  Supplementary OLS forecasting
	print("\n Supplementary OLS: ", NAMEj, " on ", NAMEk, " \n");
	dbase.DeSelect();
	dbase.Select(Y_VAR, {NAMEk, 0, 0} );	 // NAMEk aggregated series,
	dbase.Select(U_VAR,  { "Constant", 0, 0 } );	 // unrestricted constant
	dbase.Select(X_VAR, {NAMEj, 0, 0,  "Constant", 0, 0} );           // resticted Trend
	dbase.SetSelSample(mSampl[0],mSampl[1],mSampl[2],mSampl[3]); //	dbase->SetSample(1991,3,2003,3);
	my = dbase->GetGroup(Y_VAR);
	myy = my[0:rows(my)-3][];
	mx = dbase->GetGroup(X_VAR);
	mxx = mx[0:rows(mx)-3][];
	mpar = MyOls(myy, mxx);
	mPii = mpar[0];
	mPii = mPii[][0];
	/* The actual forecasting  part */
	mfy = mx*mPii;
	mfy = (mfy[(rows(my)-2):][] - my[(rows(my)-2):][])./(my[(rows(my)-2):][])*100;
	mfy = mfy'mfy; /* Vorhersagefehlerquadratsumme */
	mPii = (mPii[0]-mPi[0])/mPi[0]; // Variation of coefficient
	mPii = fabs(mPii[0]);
	print("\n End of Supplementary OLS Forecasting ", NAMEj, " on ", NAMEk, " \n \n");
//  End of Supplementary OLS forecasting
}
 else
{
//Supplementary ARMA
	CMARMA = new Arfima();		   // CMARMA is now a Arfima object!!
	CMARMA.LoadXls(quelle);		// create database as member
    CMARMA.Deterministic(FALSE);// create Constant,Trend,Seasonals
    //------------------------------------------------------- create the model
	CMARMA.DeSelect();										// formulate model
	CMARMA.Select(Y_VAR, {NAMEk,0,0} );                  // NAMEk aggregated series,
//	CMARMA.Select(Z_VAR, {NAMEj, 0, 0} );	 // explanatory Var
	CMARMA.Select(X_VAR, {"Constant", 0, 0, NAMEj, 0, 0}); //, "trend()", 0, 0} );	 
	CMARMA.SetSelSample((mSampl[0]),mSampl[1],(mSampl[2]),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
	my = CMARMA->GetGroup(Y_VAR);
	//End of sample selection	

    CMARMA.Arma(0,1);
   	CMARMA.UseSampleMean();
	CMARMA.FixD(0.0);                  			  // make sure co-integration
	CMARMA.Estimate();
	mMean = CMARMA->GetSigma2();
	mXBeta = CMARMA.GetFreePar();
	mPi = mXBeta[rows(mXBeta)-1];
	sResultate = CMARMA.GetStdErr();
	tstats = (mXBeta) ./ sResultate[1:rows(sResultate)-1];
	tstats = tstats[rows(mXBeta)-1]~tstats[1]~tstats[0];
	coeffs = mXBeta[rows(mXBeta)-1]~mXBeta[1]~mXBeta[0];
	ResCoeff[j+1][] = (coeffs~tstats) ;
	// Pseudo - R-square
	mMean = (varc(my) - mMean)/ varc(my);
	ResR2[j+1] = mMean;

	/* The actual forecasting  part */
	myy = CMARMA.GetSelEnd();
	CMARMA.SetSelSample((mSampl[0]-2),mSampl[1],(mSampl[2]-2),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
if (myy > CMARMA.GetSelEnd())
	{
	if ((rows(my)-2)>rows(mXBeta))
		{
		CMARMA.Estimate();
		mForec = CMARMA.Forecast(2); // mX in the arfima.ox code
		mXBeta = CMARMA.GetFreePar();
		mPii = mXBeta[rows(mXBeta)-1];
		mForec = (mForec[][4])./(mForec[][0] + mForec[][4])*100; // forecast statistic
		mfy = mForec'mForec; /* Vorhersagefehlerquadratsumme */
		mPii = (mPii-mPi)/mPi; // Variation of coefficient
		mPii = fabs(mPii);
		}
	}
else
	{
	mfy =-99;
	mPii = -99;
	}
	CMARMA.SetSelSample((mSampl[0]),mSampl[1],(mSampl[2]),mSampl[3]); //	{msjahr, msunterjahr, mejahr, meunterjahr, T};
// end of auxiliary ARMA
}
if (mMod <1)
	{
	ergebnis[j+1][] = CiAns[j+1]~ResCoeff[j+1][0]~ResCoeff[j+1][2]~ResR2[j+1]~mfy~mPii~rows(my);
	}
else
	{
	ergebnis[j+1][] = CiAns[j+1]~double(ResCoeff[j+1][0])~double(ResCoeff[j+1][3])~double(ResCoeff[j+1][2])~double(ResCoeff[j+1][5])~double(ResR2[j+1])~double(mfy)~double(mPii)~double(rows(my));
	}


	dbase.DeSelect();					
	++j;
	}
			format(600);
			sprintbuffer(20480);
			decl sample;
			sample = dbase.GetSelSample();
if (mMod <1)
{
	print("\nModel has NO TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], " for ", sample, "\n",
			"%r", NAME, //CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",      "R2",  "Var(F)",   "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#10.2g", "%#12.4g",  "%#12.4g", "%6.2g"},
			ergebnis,
			"\nThese results (without header) are to be found at:\n", ziel~"_F.dat",
			"\nThis file: ", ziel~"_F.txt"); 		  // ResCoeff %#d
			//	decl ergebnis; d: integer, g: double, "%#13.5g"
	ergebnis = sprint(
			"%r", NAME,	//CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",      "R2",  "Var(F)",   "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#10.2g", "%#12.4g",  "%#12.4g", "%6.2g"},
			ergebnis); 		  // ResCoeff %#d
			
	decl file = fopen((ziel~"_F.dat"), "w");
	fprint(file, ergebnis);
	fclose(file);		

	ergebnis = sprint("\nModel has NO TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], "\n",
			"%r", NAME, //CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",      "R2",  "Var(F)",   "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g", "%#8.2g", "%#12.4g",  "%#12.4g", "%6.2g"},
			ergebnis,
			"\nThese results (without header) are to be found at:\n", ziel~"_F.dat",
			"\nThis file: ", ziel~"_F.txt"); 		  // ResCoeff %#d

	file = fopen((ziel~"_F.txt"), "w");
	fprint(file, ergebnis);
	fclose(file);		
}
else
{
			format(600);
			sprintbuffer(25480);
			decl sample;
			sample = CMARMA.GetSelSample();

//  output to screen
			print("\nModel has NO TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], " for ", sample, "\n",
			"%r", NAME, //CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",     "rho",  "t(rho)", "pseudo-R2",  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g",  "%#8.2g", "%#12.4g",   "%#12.4g", "%#12.4g", "%#12.4g", "%6.2g"}
			,ergebnis,
			"\nThese results (without header) are to be found at:\n", ziel~"_Fr.dat",
			"\nThis file: ", ziel~"_Fr.txt"); 		  // ResCoeff %#d
			//	decl ergebnis; d: integer, g: double, "%#13.5g"

//  output to .dat file 
	ergebnis = sprint(
			"%r", NAME,	//CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",     "rho",  "t(rho)", "pseudo-R2",  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g",  "%#8.2g", "%#12.4g",   "%#12.4g", "%#12.4g", "%#12.4g", "%6.2g"}
			,ergebnis); 		  // ResCoeff %#d

	decl file = fopen((ziel~"_Fr.dat"), "w");
	fprint(file, ergebnis);
	fclose(file);		

// screen output to file
	ergebnis = sprint("\nModel has NO TREND in CI relation and in single quation regression\n",
				  "Cointegration analyses and single equation analysis of ", NAME[0], " for ", sample, "\n",
			"%r", NAME, //CiAns
			"%c", {	  "Joh.",  "coeff.", "t(coeff)",     "rho",  "t(rho)", "pseudo-R2",  "Var(F)",  "Var(C)",   "Obs"},
			"%cf", { "%6.1g", "%#12.4g",  "%#12.4g",  "%#8.2g", "%#12.4g",   "%#12.4g", "%#12.4g", "%#12.4g", "%6.2g"}
			,ergebnis, 
			"\nNOTE: Var(C) gives the variation of the behavioural coefficient with respect to sample size variation.\n",
			"\nIt should by no means exceed 1.\n",
			"\nThese results (without header) are to be found at:\n", ziel~"_Fr.dat",
			"\nThis file: ", ziel~"_Fr.txt"); 		  // ResCoeff %#d
	file = fopen((ziel~"_Fr.txt"), "w");
	fprint(file, ergebnis);
	fclose(file);		
	delete CMARMA;
}
	delete dbase;
// END OF MYCOINTNOT()
}

